"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const selector_util_1 = require("./selector.util");
exports.createImmutableSelector = (...keys) => ((_keys) => {
    return {
        keys: (...xKeys) => ([..._keys, ...xKeys]),
        select: (key) => exports.createImmutableSelector(..._keys, key),
        get: (state) => state.getIn(_keys),
        set: (state, key, value) => Array.isArray(key) ? state.setIn([..._keys, ...key], value) : state.setIn([..._keys, key], value),
        push: (state, key, value) => Array.isArray(key) ? state.updateIn([..._keys, ...key], (list) => list.push(value)) : state.updateIn([..._keys, key], (list) => list.push(value)),
    };
})(keys);
exports.withImmutableSelector = selector_util_1.SelectorUtil.createWithSelector(exports.createImmutableSelector);
//# sourceMappingURL=with.immutable.selector.js.map